#include <sys/types.h>
#include <sys/param.h>
#include <sys/errno.h>
#include "../include/parse.h"
#include "../include/constr.h"
#include "../include/mesg.h"
#include"../include/eye_log.h"
#include<sys/shm.h>
#include<sys/ipc.h>
#include<sys/msg.h>
#include<sys/wait.h>
#include <sys/signal.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <regex.h>
#include <sys/mman.h>
#include <sys/stat.h>

#define STARTCOUNTER	100
#define ZERO 50
#define BUFFSIZE 1024
#define REPLY "In-Reply-To:\0"

extern int errno;

char buff[BUFFSIZE],carbon[BUFFSIZE],from[BUFFSIZE],hostname[MAXHOSTNAMELEN];
char message_id[MAXHOSTNAMELEN+40];
int pid,receivesize=0,send_counter;
FILE * flerr;

char flerrname[BUFFSIZE];

Plugin * pl;
PutSection * put;

typedef struct _reg_list {
	regex_t  exp;
	int zero;
	char * id;
	CELL_M *c;
	Host *h;
	PutSection * put;
	struct _reg_list * r_next;
	} reg_list;

static	reg_list * reg_first=NULL;
	reg_list * reg_next=NULL; 


	int msgbody,msgid;

void
PrintList(){
	reg_list *reg;

	reg=reg_first;
	printf("***** Begin of the List *****\n");
	while(reg){
		printf("\n");	
		printf("Host=%s@%s\n",*(reg->h->h_adddata),reg->h->_h_addr);
		printf("Zero=%d\n",reg->zero);
		printf("ID=%s\n",reg->id);	
		printf("\n");	
		reg=reg->r_next;
	}
	
	printf("***** End of the List *****\n");
}

void
ResetID(int sig)
	{
	signal(sig,ResetID);
	printf("Signal %d received \n",sig);
}

void
WaitChaild(int sig)
    {
    int status;
    signal(sig,WaitChaild);
    while(waitpid(-1,&status,WNOHANG)>0);
#ifdef DEBUG
        flerr=freopen(flerrname,"a",stdout);
        printf("Signal %d received \n",sig);
        printf("Chaild catched \n");
        fclose(flerr);
#endif
}

void
End_ (int sig)
{
	msgctl(msgid,IPC_RMID,0);
	msgctl(msgbody,IPC_RMID,0);
	remove("/var/tmp/eye_mail.pid");
	while(waitpid(-1,&pid,WNOHANG)>0);	
	while(reg_first)
		{
		regfree(&(reg_first->exp));
		free(reg_first->id);
		reg_next=reg_first->r_next;
		free(reg_first);
		reg_first=reg_next;
	}
	exit(0);
}

void
SendMail(reg_list * reg)
	{
	int socket[2],pid,nbytes;
	Message message;
	CELL_M *ce;
	Host *ho;
	char fr[BUFFSIZE];
	char message_id_[MAXHOSTNAMELEN+40];
	int s0,s1;

	strcpy(fr,"-f \0");
	strcat(fr,from);

	ce=reg->c;
	ho=reg->h;
	pipe(socket);
	send_counter++;
	sprintf(message_id_,"<%d.%s>",send_counter,message_id);
	pid=fork();
	if (!pid)
		{
	//	close(0);
		close(socket[1]);
		s0=dup2(socket[0],0);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("socket[0]=%d errno=%d\n",s0,errno);
	fclose(flerr);
#endif
		execlp("sendmail","sendmail","-i","-t",fr,NULL);
		close(socket[0]);
		exit(0);
	}

	close(socket[0]);
// Message composing
	s0=write(socket[1],"To: <",5);
	write(socket[1],*(ho->h_adddata),strlen(*(ho->h_adddata)));
	write(socket[1],"@",1);
	s1=write(socket[1],ho->_h_addr,strlen(ho->_h_addr));
	write(socket[1],">\n",2);
	write(socket[1],"Message-ID: ",12);
	write(socket[1],message_id_,strlen(message_id_));
	write(socket[1],"\n",1);
/*
	write(socket[1],"Cc: <",5);
	write(socket[1],carbon,strlen(carbon));
	write(socket[1],">\n",2);
*/

	write(socket[1],"Subject: ",9);
	write(socket[1],"test\n",5);

#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	s0=write(1,"To: <",5);
	write(1,*(ho->h_adddata),strlen(*(ho->h_adddata)));
	write(1,"@",1);
	s1=write(1,ho->_h_addr,strlen(ho->_h_addr));
	write(1,">\n",2);
	write(1,"Cc: <",5);
	write(1,carbon,strlen(carbon));
	write(1,">\n",2);
	write(1,"Subject: ",9);
	write(1,"test\n",5);
	printf("Write to socket[1] %d %d\n",s0,s1);
	fclose(flerr);
#endif
	write(socket[1],"\n",1);
	if(*(ho->h_adddata+3)) write(socket[1],*(ho->h_adddata+3),strlen(*(ho->h_adddata+3)));
	close (socket[1]);
/* Close due to Message-ID manyal setting */
/*	alarm(5);
	while((nbytes=msgrcv(msgid,&message,MESGBUFF,0,0))<0);
	if(nbytes<0)
		{
		if(ce->status!=3) {
			ce->rate=0; 
			writedblog(pl->NameOfCfg,reg->h->h_key,ce->status);
		}//Could not send message at first time
		ce->status=3;//Could not send message
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Could not send message \n");
	perror("SendMail: msgrcv");
	fclose(flerr);
#endif
		reg->zero=20;//Inter trying gap
	}
	else	*/

	{
		if(reg->id) free(reg->id);
		reg->id=(char *)malloc(strlen(message_id_)+1);
		strcpy(reg->id,message_id_);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Mail: message=%s\n",message.buff);
	printf("Mail: ID=%s\n",reg->id);
	fclose(flerr);
#endif
		if(*(ho->h_adddata+2)) reg->zero=atoi(*(ho->h_adddata+2));
			else reg->zero=ZERO;
		if((ce->status)!=0) {
			if(ce->status!=4)writedblog(pl->NameOfCfg,reg->h->h_key,4);
			ce->status=4;
			ce->rate=0;//Message sent 
			if(*(ho->h_adddata+2)) ce->cell=atoi(*(ho->h_adddata+2));
				else ce->cell=ZERO;
		}
	}

#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	PrintList();
	fclose(flerr);
#endif

}


void
ProcessMail()
        {
        int pid,status;
        Message message;
        int fd;
        struct stat filestat;
        caddr_t map;
        char * idbegin,* idend;
        reg_list *reg;
        size_t nmatch;
        regmatch_t *pmatch;
        CELL_M *ce;

        while (nmatch=msgrcv(msgbody, &message,MESGBUFF,1,IPC_NOWAIT)<0) return;
        pid=fork();
        if(!pid)
        {
#if DEBUG
        flerr=freopen(flerrname,"a",stdout);
        printf("ProcessMail: message=%s\n",message.buff);
        fclose(flerr);
#endif

        //Finding Message-ID (In-Reply-To)
        idbegin=strstr((char *) message.buff,REPLY);
#if DEBUG
        flerr=freopen(flerrname,"a",stdout);
        printf("ProcessMail: idbegin=%d ID=",idbegin);
	fwrite(idbegin,sizeof(char),50,flerr);
	printf("\n");
        fclose(flerr);
#endif


        idbegin=strchr(idbegin,'<');
        idend=strchr(idbegin,'>');

        //Comparing with existing in reg_list ID
        reg=reg_first;
        while(reg) {

#if DEBUG
        flerr=freopen(flerrname,"a",stdout);
        printf("ProcessMail: messageID=");
        fwrite(idbegin,sizeof(char),idend-idbegin+1,flerr);
        printf("\n");
        printf("ProcessMail: regID=%s\n",reg->id);
        printf("Processmail: *****************\n");
        fclose(flerr);
#endif

            if(!(strncmp(reg->id,idbegin,idend-idbegin+1))) break;
            reg=reg->r_next;
        }
        if (!reg) {
            exit(3);//Non existing ID
        }

        ce=reg->c;

        //Finding regexpression
        if(!regexec(&(reg->exp),message.buff,nmatch,pmatch,0)) {
		if(ce->status!=0){ 
			ce->rate=0;
			writedblog(pl->NameOfCfg,reg->h->h_key,0);
		}           
		 ce->status=0;
            if(*((reg->h)->h_adddata+1)) ce->cell=atoi(*((reg->h)->h_adddata+1));
                else ce->cell=STARTCOUNTER;
        }
        else {
       		if((ce->status!=2)){ 
			ce->rate=0;
			writedblog(pl->NameOfCfg,reg->h->h_key,2);
		}
		ce->status=2;//Regexp not matched 
        }
        exit(0);
        }//End chaild
#if DEBUG
        flerr=freopen(flerrname,"a",stdout);
	printf("ProcessMail: msgrcv returns %d\n",status);
        fclose(flerr);
#endif

}

void
main(int argc,char * argv[])
{

	key_t key;
	int i,j,fl;
	long len;
	char * mem;

	Command *c;
	Host * ho;
	CELL_M *ce,*plce;
	short *sh, *shp;
	short sendtime=0;
	int n=0;
	CELL StartCounter=0;
	char * begin,data[BUFFSIZE];

	key_t msgkey1,msgkey2;
	struct msgid_ds   *msgbuf1,  *msgbuf2;


	int fdpid;
	if(argc<2) 
		{
		printf("Missing .cfg file as first parametr\n");
		exit(1);
	}
	printf("Mail: Cfg file %s\n",argv[1]);

//Otkrytie nuzhnogo .cfg failov
	fl=OpenCfgFile(argv[1],0);
 	if(fl==OCF_CANNOTOPEN)
       		 {
       		 printf("Cannot open cfg file\n");
       		 exit(1);
    	}
	printf("Mail: Cfg opened\n");
	pl=GetFirstPlugin();
//End

//Set message_id as send_counter.eye_mail.pid@hostname
	gethostname(hostname,MAXHOSTNAMELEN);
	sprintf(message_id,"eye_mail.%d@%s",getpid(),hostname); 
//End

//Podsoedinenie SHM
	if (argc<1) printf("Argument missing\n"),exit(1);
	if((key=ftok((argc>2) ? argv[2] : "/var/tmp",'e'))<0) perror("ftok"),exit(1);
	if((i=shmget(key,4,0660))<0)perror("shmget1"),exit(1);
	if((mem=shmat(i,0,0660))<0)perror("shmat"),exit(1);
	len=*((long *) mem);
	if((shmdt(mem))<0)perror("shmdt"),exit(1);
	if((i=shmget(key,len,0660))<0)perror("shmget2"),exit(1);
	if((mem=shmat(i,0,0660))<0)perror("shmat"),exit(1);
//End

//Ustanovka signala okonchyaniya
	signal(SIGTERM,End_);
	signal(SIGHUP,End_);
	
//Zapis' PID'a v fail
	fdpid=open("/var/tmp/eye_mail.pid",O_CREAT | O_WRONLY);
	pid=getpid();
	write(fdpid,&pid,sizeof(pid));
	close(fdpid); 


//Otkrytie MSG dlya peredachi tela soobsheniya
	msgkey1=ftok((argc>2) ? argv[2] : "/var/tmp",'b');
	msgbody=msgget(msgkey1,0666 | IPC_CREAT);
	msgctl(msgbody,IPC_STAT,(struct msqid_ds *) msgbuf1);

//Otkrytie MSG dlya peredachi ID soobsheniya
	msgkey2=ftok((argc>2) ? argv[2] : "/var/tmp",'i');
	msgid=msgget(msgkey2,0666 | IPC_CREAT);
	msgctl(msgid,IPC_STAT,(struct msqid_ds *) msgbuf2);

	plce=GetStatusByName(pl->NameOfCfg,mem);

//Poluchenie parametrov iz .cfg faila	
	 for(c=pl->p_cmd; c; c=c->c_next)
 	 	{
        	if(!strcasecmp(c->c_cmd,"StartCounter")) 
        		{       
            		StartCounter=atoi(c->c_value);
	}else if(!strcasecmp(c->c_cmd, "SendTime")) 
        		{       
            		sendtime=atoi(c->c_value);
        	}
	else if(!strcasecmp(c->c_cmd, "MaxReceiveSize")) 
        		{       
            		receivesize=atoi(c->c_value);
        	}
	else if(!strcasecmp(c->c_cmd, "LogFile")) 
        		{       
            		strcpy(flerrname,c->c_value);
        	}
	else if(!strcasecmp(c->c_cmd, "CarbonCopy")) 
        		{       
            		strcpy(carbon,c->c_value);
        	}
	else if(!strcasecmp(c->c_cmd, "From")) 
        		{       
            		strcpy(from,c->c_value);
        	}
    	}
	if(!sendtime) sendtime=10;
	if(!StartCounter) StartCounter=10;
	if(!receivesize) receivesize=10000;

#if DEBUG
	remove(flerrname);
#endif
/*
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("msgkey1=%d  msgbody=%d msg_perm=%o\n",msgkey1,msgbody,msgbuf1->msg_qbytes);
	printf("msgkey2=%d  msgid=%d msg_perm=%o\n",msgkey2,msgid,(msgbuf2->msg_perm).mode);
	fclose(flerr);
#endif  */

#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Message_id is %s\n",message_id);
	fclose(flerr);
#endif


#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("msgkey1=%d  msgbody=%d\n",msgkey1,msgbody);
	printf("msgkey2=%d  msgid=%d\n",msgkey2,msgid);
	printf("PID=%d\n",pid);
	printf("Size of reg_list=%d\n",sizeof(reg_list));
	fclose(flerr);
#endif

//Kompilyazciya regulyarnyh vyrazheniy i proverka oshibok v resolvinge
if(!(sh=GetCfgByName(pl->NameOfCfg,mem)))
       	{
        perror("  SHM   pl->NameOfCfg\n");
	plce->status=3;plce->rate=0;	
        exit(1);
}
for (put=pl->ps_next;put;put=put->ps_next)
	{
	if(!(shp=GetPutByName(put->ps_name,sh))) 
       		{
               	perror("  SHM  put->ps_name\n");
 		plce->status=3;plce->rate=0;	
               	exit(1);
       	}
	for(ho=put->h_next;ho;ho=ho->h_next)
		{
		n++;
		ce=GetCELL_M(shp);
        	if(!ce) break;
		if (reg_first==NULL) reg_first=reg_next=(reg_list *)malloc(sizeof(reg_list));
			else {reg_next->r_next=(reg_list *)malloc(sizeof(reg_list));reg_next=reg_next->r_next;}

#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("malloc at addres %d\n",reg_next);
	printf("AddData is %s\n",*(ho->h_adddata+4));
	fclose(flerr);
#endif

		if(!(*(ho->h_adddata+4))) strcpy(data,".*\0");
			else strcpy(data,*(ho->h_adddata+4));//Pervym idet /, kotoryi nuzhen dlya adddata v parsere
		if(regcomp(&(reg_next->exp),data,REG_NOSUB)) ce->status=5;//Ne mogu otkompilirovat' reg expr
	
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Data is %s\n",data);
	printf("regcomp passed\n");
	fclose(flerr);
#endif

		reg_next->c=ce;
		reg_next->zero=0;
		reg_next->h=ho;
		reg_next->put=put;
		reg_next->id=NULL;
		reg_next->r_next=NULL;	
	} 
}


//Ustanovka signala dlya prihoda pochty
// signal(SIGUSR1,ProcessMail);
//Ustanovka alarma dlya razblokirovaniya ozhidaniya MESSAGE-ID
signal(SIGALRM,ResetID);
//Ustanovka signala dlya podbora zombi
signal(SIGCHLD,WaitChaild);

#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Totally %d cells\n",n);
	printf("Signal set passed\n");
	fclose(flerr);
#endif



//Bol'shoi zcikl
while(1)
	{
	reg_next=reg_first;
	while(reg_next)
		{
		if (reg_next->zero<1) SendMail(reg_next);
		(reg_next->zero)--;
		reg_next=reg_next->r_next;
	}
	if((n=sleep(1))) sleep(n);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf(".\n",n);
	fclose(flerr);
#endif
        ProcessMail();
}
}//main()
