#include <sys/types.h>
#include<sys/shm.h>
#include<sys/ipc.h>
#include<sys/time.h>
#include<sys/resource.h>
#include<sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <netdb.h>
#include <unistd.h>
#include "../include/signal.h"
#include "../include/parse.h"
#include "../include/constr.h"
#include "../include/eye_log.h"

#define BUFFSIZE 255
#define PORTNUM  25 

char buff[BUFFSIZE];

extern int CurChaildNumber, ChaildNumber;
extern pid_t *ChaildHolder;

int
End_(int sig){
#ifdef DEBUG
	{
	int t;
	flerr=freopen(flerrname,"a",stdout);
        for(t=0;t<ChaildNumber;t++)printf("ChaildPid=%d\n",*(ChaildHolder+t));
	fclose(flerr);
	}
#endif
End(sig);
}

int
main(int argc,char * argv[])
{

	key_t key;
	int i,j,fl,sl;
	long len;
	char * mem;

//Dlya ispytanii GetCELL_MByName
	Plugin * pl;
	PutSection * put;
	Command *c;
	Host * ho;
	CELL_M *ce,*plce;
	short *sh, *shp;
	short sendtime=0;
	CELL StartCounter=0;

//Dlya socketov
	int s;
	int pid,status;
	int nport;
	struct sockaddr_in serv_addr;	
	struct hostent *hp;

	if(argc==1) 
		{
		printf("Missing .cfg file as first parametr\n");
		exit(1);
	}
	printf("Cfg file %s\n",argv[1]);

//Otkrytie vseh .cfg failov
	fl=OpenCfgFile(argv[1],0);
 	if(fl==OCF_CANNOTOPEN)
       		 {
       		 printf("Cannot open cfg file\n");
       		 exit(1);
    	}
#if DEBUG
	printf("SMTP: Cfg opened\n");
#endif

	pl=GetFirstPlugin();
#if DEBUG
	printf("SMTP: first plugin=%d\n",pl);
#endif
//End

//Podsoedinenie SHM
	if (argc<1) printf("Argument missing\n"),exit(1);
	if((key=ftok((argc>2) ? argv[2] : "/var/tmp",'e'))<0) perror("ftok"),exit(1);
	if((i=shmget(key,4,0660))<0)perror("shmget1"),exit(1);
	if((mem=shmat(i,0,0660))<0)perror("shmat"),exit(1);
	len=*((long *) mem);
	if((shmdt(mem))<0)perror("shmdt"),exit(1);
	if((i=shmget(key,len,0660))<0)perror("shmget2"),exit(1);
	if((mem=shmat(i,0,0660))<0)perror("shmat"),exit(1);
//End
	plce=GetStatusByName(pl->NameOfCfg,mem);

#if DEBUG
	printf("SMTP: Shm mem=%d, plce=%d\n",mem,plce);
#endif
	
	 for(c=pl->p_cmd; c; c=c->c_next)
 	 	{
        	if(!strcasecmp(c->c_cmd,"StartCounter")) 
            		StartCounter=atoi(c->c_value);
        	if(!strcasecmp(c->c_cmd, "SendTime")) 
            		sendtime=atoi(c->c_value);
		if(!strcasecmp(c->c_cmd, "LogFile"))
                        strcpy(flerrname,c->c_value);
		if(!strcasecmp(c->c_cmd, "ChaildNumber"))
			ChaildNumber=atoi(c->c_value);
    	}
	if(!sendtime) sendtime=10;
	if(!StartCounter) StartCounter=10;
	if(!ChaildNumber) ChaildNumber=GetHostNumber(pl);

ChaildHolder=(int *) malloc(ChaildNumber*sizeof(pid_t));

#if DEBUG
	printf("SMTP: Errorfile %s\n",flerrname);
	remove(flerrname);
#endif


#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Sendtime=%d\n",sendtime);
	fclose(flerr);
#endif

//Ustanovka signala dlya podhvata detei-zombi
signal(SIGCHLD,WaitChaild);
signal(SIGINT,KillChaild);
signal(SIGHUP,End_);


//Bol'shoi zcikl
while(1)
	{
	put=pl->ps_next;
	if(!(sh=GetCfgByName(pl->NameOfCfg,mem)))
        	{
                perror("  SHM\n");
 		plce->status=3;plce->rate=0;	
                exit(1);
        }
	while(put)
		{
		if(!(shp=GetPutByName(put->ps_name,sh))) 
        		{
                	perror("  SHM\n");
 			plce->status=3;plce->rate=0;	
                	exit(1);
        	}
		ho=put->h_next;
		while(ho)
			{
			pid_t *pid_holder;
			if(atoi(*(ho->h_adddata))) nport=atoi(*(ho->h_adddata));
			else nport = PORTNUM;
			nport = htons((u_short)nport);
			ce=GetCELL_M(shp);
        		if(!ce) break;
			if (CurChaildNumber>=ChaildNumber) sleep(1);
			if(pid_holder=GetEmptySlot()){ *(pid_holder)=pid=fork(); CurChaildNumber++;}
                                 else raise(SIGINT);
			if(!pid)
			{
			hp = gethostbyname(ho->_h_addr);
			if ((!hp)) //Error in resolve 
				{
				if(!(ce->status==4)){ce->rate=0;writedblog(pl->NameOfCfg,ho->h_key,ce->status);}
				ce->status=4;
				exit(4);
			}
			bzero(&serv_addr,sizeof(serv_addr));
			bcopy(hp->h_addr, &serv_addr.sin_addr, hp->h_length);
       			serv_addr.sin_family = AF_INET;
       			serv_addr.sin_port = nport;
        		if(((s = socket(AF_INET,SOCK_STREAM,0)) == -1)&&(plce->status!=2))
        			{
            			perror("  socket()\n");
				plce->status=2;plce->rate=0;	
            			exit(1);
        		}
			if(connect(s,(struct sockaddr *)&serv_addr, sizeof(serv_addr))==-1)
        			{
            			perror("  connect()\n");//Vremenno v sostoyanii DOWN
				if((ce->status!=1)&& (ce->status!=0)) ce->cell=StartCounter;
				if(ce->status!=1) ce->status=0;
				close(s);
        			exit(1);
			} 
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
					printf("%s connected\n",ho->_h_addr);
	fclose(flerr);
#endif
			recv(s,buff,sizeof(buff),0);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
			printf("%s\n",buff);
	fclose(flerr);
#endif
			if ((strncmp(buff,"220",3))){
				if (ce->status!=5){writedblog(pl->NameOfCfg,ho->h_key,5); ce->rate=0;ce->status=5;}
				exit(0);
			}
	        	{
            		int nbytes;
            		int fout;
			strcpy(buff,"ehlo \0");
			strcat(buff,ho->_h_addr);
			strcat(buff,"\n");
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("%s sending...\n",buff);
	fclose(flerr);
#endif
			fout=send(s,buff,strlen(buff),0);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
			printf("sended %d bytes\n",fout);
            		printf("receving...\n");
	fclose(flerr);
#endif
			nbytes=recv(s,buff,sizeof(buff),0);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
            		printf("%s %d\n",buff,nbytes);
	fclose(flerr);
#endif
                	if(strncmp(buff,"250",3))//Ne ponimaet MIME
				{
				if(ce->status!=2){ 
					ce->rate=0;
					ce->status=2;
					writedblog(pl->NameOfCfg,ho->h_key,ce->status);
				} 
				exit(2);
			}
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
			printf("quit sending...\n");
	fclose(flerr);
#endif
			fout=send(s,"quit\n",5,0);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
			printf("sended %d bytes\n",fout);
                    	printf("receving...\n");
	fclose(flerr);
#endif
			while(recv(s,buff,sizeof(buff),0))
				{
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
                        printf("%s %d\n",buff,nbytes);
	fclose(flerr);
#endif
			}
			}
		
			ce->cell=StartCounter;
			if(ce->status!=0) {writedblog(pl->NameOfCfg,ho->h_key,0);ce->rate=0;
				ce->status=0;
			}

			close(s);	
			exit(1);
			}//End fork()
			ho=ho->h_next;
		}
		put=put->ps_next;
	}
#ifdef DEBUG
	{
	int t;
	flerr=freopen(flerrname,"a",stdout);
        for(t=0;t<ChaildNumber;t++)printf("ChaildPid=%d\n",*(ChaildHolder+t));
	fclose(flerr);
	}
#endif

sl=sendtime;
while(sl=sleep(sl)); {

#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
        printf("...sl=%d\n",sl);
	fclose(flerr);
#endif

}
	
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
                        		printf("All chaild catched ***** Next ****** cicle ******\n");
	fclose(flerr);
#endif
}
exit(0);
}//main()
